Card Game Cheater HDU - 1962 (二分图匹配)

Adam and Eve play a card game using a regular deck of 52 cards. The rules are simple. The players sit on opposite sides of a table, facing each other. Each player gets k cards from the deck and, after looking at them, places the cards face down in a row on the table. Adam’s cards are numbered from 1 to k from his left, and Eve’s cards are numbered 1 to k from her right (so Eve’s i:th card is opposite Adam’s i:th card). The cards are turned face up, and points are awarded as follows (for each i ∈ {1, . . . , k}):
• If Adam’s i:th card beats Eve’s i:th card, then Adam gets one point.
• If Eve’s i:th card beats Adam’s i:th card, then Eve gets one point.
• A card with higher value always beats a card with a lower value: a three beats a two, a four beats a three and a two, etc. An ace beats every card except (possibly) another ace.
• If the two i:th cards have the same value, then the suit determines who wins: hearts beats all other suits, spades beats all suits except hearts, diamond beats only clubs, and clubs does not beat any suit.

For example, the ten of spades beats the ten of diamonds but not the Jack of clubs. This ought to be a game of chance, but lately Eve is winning most of the time, and the reason is that she has started to use marked cards. In other words, she knows which cards Adam has on the table before he turns them face up. Using this information she orders her own cards so that she gets as many points as possible.

Your task is to, given Adam’s and Eve’s cards, determine how many points Eve will get if she plays optimally.

Input

There will be several test cases. The first line of input will contain a single positive integer N giving the number of test cases. After that line follow the test cases.

Each test case starts with a line with a single positive integer k ≤ 26 which is the number of cards each player gets. The next line describes the k cards Adam has placed on the table, left to right. The next line describes the k cards Eve has (but she has not yet placed them on the table). A card is described by two characters, the first one being its value (2, 3, 4, 5, 6, 7, 8 ,9, T, J, Q, K, or A), and the second one being its suit (C, D, S, or H). Cards are separated by white spaces. So if Adam’s cards are the ten of clubs, the two of hearts, and the Jack of diamonds, that could be described by the line

TC 2H JD

Output

For each test case output a single line with the number of points Eve gets if she picks the optimal way to arrange her cards on the table.

Sample Input

3
1
JD
JH
2
5D TC
4C 5H
3
2H 3H 4H
2D 3D 4D

Sample Output

1
1
2

关于二分图匹配
图论术语中,将一种两两不含公共端点的的边边的集合M成为匹配,而元素最多的集合则称为最大匹配。特别地。二分图中的匹配称为二分图匹配。二分图匹配常常在指派问题的模型中出现。

题意:
这个题是纸牌游戏,题目中重要的是:
红心赢所有其他花色,黑桃赢除红心外的所有花色,菱形只赢梅花,梅花不赢任何花色。(即红心H最大其次黑桃S然后菱形D(或方块)最后梅花C),求夏娃出最优牌能赢多少分。

思路:
由于题目中给的字母字典序不是按顺序给的,所以我们可以对题目所给字母进行加工变化,使其更加容易排序并进行比较,下面直接看代码吧!

#include<stdio.h>
#include<string.h>
#include<algorithm>
using namespace std;
struct card
{
    char a[3];
}b[50],c[50];
bool cmp(card x,card y)
{
    return strcmp(x.a,y.a)>0;
}
int main()
{
    int t;
    scanf("%d",&t);
    while(t--)
    {
        int n,i;
        scanf("%d",&n);
        for(i=0; i<n; i++)
        {
            scanf("%s",b[i].a);
            if(b[i].a[0]=='T')
                b[i].a[0]='A';
            else if(b[i].a[0]=='J')
                b[i].a[0]='B';
            else if(b[i].a[0]=='Q')
                b[i].a[0]='C';
            else if(b[i].a[0]=='K')
                b[i].a[0]='D';
            else if(b[i].a[0]=='A')
                b[i].a[0]='E';

            //从大到小 红心H 黑桃S 方块D 梅花C
            if(b[i].a[1]=='C')
                b[i].a[1]='A';
            else if(b[i].a[1]=='D')
                b[i].a[1]='B';
            else if(b[i].a[1]=='S')
                b[i].a[1]='C';
            else if(b[i].a[1]=='H')
                b[i].a[1]='D';

        }
        for(i=0;i<n;i++)
        {
            scanf("%s",c[i].a);
            if(c[i].a[0]=='T')
                c[i].a[0]='A';
            else if(c[i].a[0]=='J')
                c[i].a[0]='B';
            else if(c[i].a[0]=='Q')
                c[i].a[0]='C';
            else if(c[i].a[0]=='K')
                c[i].a[0]='D';
            else if(c[i].a[0]=='A')
                c[i].a[0]='E';


            if(c[i].a[1]=='C')
                c[i].a[1]='A';
            else if(c[i].a[1]=='D')
                c[i].a[1]='B';
            else if(c[i].a[1]=='S')
                c[i].a[1]='C';
            else if(c[i].a[1]=='H')
                c[i].a[1]='D';
        }
        sort(b,b+n,cmp);
        sort(c,c+n,cmp);
 
        int j,k=0,sum=0;
        for(i=0;i<n;i++)
        {
            for(j=k;j<n;j++)
            {
                if(strcmp(b[i].a,c[j].a)<0)
                {
                    k=j+1;
                    sum++;
                    break;
                }
            }
        }
        printf("%d\n",sum);
    }
        return 0;
}

猜你喜欢

转载自blog.csdn.net/Piink/article/details/105167559